﻿/*
*	どらごーん
*/


class Dragon01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "enemy01.png", "Dragon01", 10, 64*0, 64*0, 64, 64 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Dragon01"
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -12, -16, 12, 24 )
		detail.Flag = (ColFlagD.ColMap | ColFlagD.ColObj)
		detail.Target = eObjType.Player
		detail.Damage = 100
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "Dragon01", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		if( o.L0 == 0 ){
			if( ++o.L2 > 120 ){
				++o.L0
				o.L2 = 0
			}
		}
		else{
			if( ++o.L2 % 4 == 0 ){
				GameObject.CreateObjectFromName( "DragonFire01", o.Pos, o.Dir ).Pos.Add( 8 * (o.Dir == DIR_LEFT ? -1 : 1), 6 )
			}
			if( o.L2 > 60 ){
				--o.L0
				o.L2 = 0
			}
		}
	}
	
	
	/*
	*	描画
	*/
	function Draw(o)
	{
		o.Turn.X = (o.Dir == DIR_LEFT)
		
		if( o.L0 == 1 ) o.Src.Y += o.Src.H * 4
		
		++o.L1
		
		local i = 0
		foreach(n in [ 0, 1, 2, 3 ]){
			if( o.L1 < 8*(i+1) ){
				o.Src.Y += o.Src.H * n
				return
			}
			++i
		}
		
		o.L1 = 0
	}
}


class DragonFire01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "32.png", "DragonFire01", 10, 32*0, 32*7, 32, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "DragonFire01"
		obj.Scale2D.Set( 0.1 )
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -12, -12, 12, 12 )
		detail.Flag = ColFlagD.ColMap
		detail.Target = eObjType.Player
		detail.Damage = 100
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "DragonFire01", eObjType.Enemy )
	}
	
	
	/*
	*	初期化
	*/
	function Init(o)
	{
		o.Speed.Set( 8 * (o.Dir == DIR_LEFT ? -1 : 1), -0.25 )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		o.Scale2D.Add( 0.05 )
		if( o.Scale2D.X > 1 ) o.Valid = false
	}
}


Dragon01()
DragonFire01()
