﻿/*
*	れーざー
*/


class Laser extends GameObjectBase
{
	/*
	*	生成関数
	*/
	function Make(pos, angle, speed)
	{
		local c = GameObject.CreateObjectFromName( "Laser", pos, DIR_INVALID )
		c.Angle = angle
		c.F0 = speed
		
		return c
	}
	
	
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "Laser.png", "Laser", 50, 0, 0, 64, 64 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Laser"
		obj.Flag	= 1
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorCircle( 0, 0, 32 )
		detail.Target = eObjType.Player
		detail.Damage = 400
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "Laser", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		if( !o.L1 ){
			++o.L1
			
			switch( o.L0 ){
				case 0:
					local c = GameObject.CreateObjectFromName( "Laser", o.Pos, o.Dir )
					c.L0 = 1
					c.Angle = o.Angle
					o.Link.Link( c )
					break
					
				case 1:
					break
			}
		}
		
		
		switch( o.L0 ){
			case 0:
				if( ++o.L2 > 10 ){
					o.Scale2D.X *= 0.8
					if( o.Scale2D.X <= 0.05 ) o.Valid = false
				}
				break
				
			case 1:
				if( o.Link.HasParent ){
					local p = o.Link.Parent
					
					o.F1 += p.F0
					o.Angle = p.Angle
					o.Scale2D = p.Scale2D
					
					local radian = o.Angle * PI * 2
					local radius = o.F1 + (64 - p.F0)
					o.Pos = p.Pos + SPoint2DF.ctor( radius * cos( radian ), radius * sin( radian ) )
					
					local c = GameObject.CreateObjectFromName( "Laser_Child", o.Pos, o.Dir )
					c.F1 = o.F1
					o.Link.Link( c )
				}
				else o.Valid = false
				
				break
		}
	}
}


class Laser_Child extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "Laser.png", "Laser_Child", 51, 64, 0, 64, 64 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Laser_Child"
		obj.Flag	= 1
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -32, -32, 32, 32 )
		detail.Target = eObjType.Player
		detail.Damage = 400
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "Laser_Child", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		if( o.Link.HasParent ){
			if( o.Link.Parent.Link.HasParent ){
				local p = o.Link.Parent.Link.Parent
				
				o.Angle = p.Angle
				o.Scale2D = p.Scale2D
				
				local radian = o.Angle * PI * 2
				local radius = o.F1 - (p.F0 - 32)
				o.Pos = p.Pos + SPoint2DF.ctor( radius * cos( radian ), radius * sin( radian ) )
				
				return
			}
		}
		o.Valid = false
	}
}


Laser()
Laser_Child()
