﻿/*
*	
*/


class LaserBomb extends GameObjectBase
{
	/*
	*	生成関数
	*/
	function Make(pos, sx, sy)
	{
		local c = GameObject.CreateObjectFromName( "LaserBomb", pos, DIR_INVALID )
		c.Speed.Set( sx, sy )
		
		return c
	}
	function MakeNum(pos, sx, sy, num)
	{
		local a = 1.0 / num
		local b = (num - 1).tofloat() * 0.5 * -sx
		for(local i=0; i < num; ++i)
			LaserBomb.Make( pos, b + i * sx, sy )
	}
	
	
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "32.png", "LaserBomb", 50, 0, 64, 32, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "LaserBomb"
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -16, -16, 16, 16 )
		detail.Flag	= ColFlagD.ColMap
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "LaserBomb", eObjType.Enemy )
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		o.Speed.Y += 0.4
		if( o.ColDir ){
			Laser.Make( o.Pos, -0.25, 62 )
			o.Valid = false
		}
	}
}


LaserBomb()
