﻿/*
*	ぴこはん
*/


class Pikohan extends GameObjectBase
{
	/*
	*	生成関数
	*/
	function Make(pos, dir)
	{
		return GameObject.CreateObjectFromName( "Pikohan", pos, dir )
	}
	
	
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "sub_01.png", "Pikohan", 100, 0, 128, 64, 64 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Pikohan"
		obj.RotatePos.Set( 0, 24 )
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -16, -16, 16, 16 )
		detail.Flag = ColFlagD.ColObj
		detail.Target = eObjType.Player
		detail.Damage = 10000
		obj.Col.PushDetail( detail )
		
		// 登録
		GameObjectBase.constructor( obj, "Pikohan", eObjType.Enemy )
	}
	
	
	/*
	*	初期化
	*/
	function Init(o)
	{
		o.Angle = (o.Dir & DIR_LEFT ? 0.375 + 0.5 : 1.125 - 0.5)
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		if( o.Link.HasParent ){
			o.Pos.Set( o.Link.Parent.Pos.X + 14 * (o.Dir & DIR_LEFT ? -1 : 1), o.Link.Parent.Pos.Y + 12 )
		}
		
		switch( o.L0 ){
			case 0:
				break
				
			case 1:
				if( o.Dir & DIR_LEFT ){ if( (o.Angle -= 0.1) <= 0.375 ){ o.Angle = 0.375; ++o.L0 } }
				else                  { if( (o.Angle += 0.1) >= 1.125 ){ o.Angle = 1.125; ++o.L0 } }
				break
				
			case 2:
				if( ++o.L1 >= 30 ) o.Valid = false
				break
		}
	}
}


Pikohan()
