﻿/*
*	あ
*/


class DamageCount extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "num_pt3.png", "DamageCount", 10000, 0, 0, 16, 32 )

		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Speed.Y	= -0.8
		
		// 登録
		GameObjectBase.constructor( obj, "DamageCount", eObjType.Effect )
	}
	
	
	/*
	*	描画
	*/
	function Draw(o)
	{
		if( ++o.L1 > 20 ){
			o.Color.a -= 0.1
			if( o.Color.a <= 0 ) o.Valid = false
		}
		
		local tex = My.CTextureInterface()
		local pTex = tex.Find("DamageCount")
		
		local numStr = o.L0.tostring()
		local numLen = numStr.len()
		local dst = o.Dst.Clone()
		dst.X -= 32
		dst.Y -= 64
		
		for(local i=0; i < numLen; ++i){
			local src = pTex.Src.Clone()
			src.X = numStr.slice( i, i+1 ).tointeger() * src.W
			dst.X += src.W
			//pTex.Draw( src, dst, pTex.Priority, o.Scale2D, o.Color, AB_BLEND )
		}
	}
}
DamageCount()




class MsgManager
{
	OnMsgArea	= false
	OnWaitArea	= false
	WaitFrame	= 0
	SubCharaID	= 0
	MsgID		= 0
	Alpha		= 0
	Pos			= SPoint2DF.ctor( 4, 68 )
	Scale		= SPoint2DF.ctor( 1, 1 )
	
	
	function Set(msgID, onWaitArea)
	{
		OnMsgArea	= true
		OnWaitArea	= onWaitArea
		MsgID		= msgID
	}
	function Update()
	{
		// アルファ
		Alpha += 0.05 * (OnMsgArea && (!OnWaitArea || WaitFrame >= 150) ? 1 : -1)
		if     ( Alpha < 0 ) Alpha = 0
		else if( Alpha > 1 ) Alpha = 1
		
		// 待ち
		if( OnWaitArea && OnMsgArea ) ++WaitFrame
		else                          WaitFrame = 0
		
		OnMsgArea	= false
		OnWaitArea	= false
	}
	function Draw()
	{
		if( Alpha > 0 ){
			if( SubCharaID in msgList ){
				if( MsgID in msgList[ SubCharaID ] ){
					local tex = My.CTextureInterface()
					local pTex = tex.Find("TalkWindow")
					pTex.Draw( pTex.Src, Pos, pTex.Priority, Scale, SColor.ctor( 1, 1, 1, Alpha ), AB_BLEND )
					
					local font = My.CFontInterface.Find("mika")
					font.Draw( msgList[ SubCharaID ][ MsgID ], SPoint2DF.ctor( 8, 80 ), font.Priority, SColor.ctor( 0, 0, 0, Alpha ), AB_BLEND )
				}
			}
		}
	}
}
msgManager <- MsgManager()




class Sub01 extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "32.png", "Sub01", 20, 32*0, 32*6, 32, 32 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Sub01"
		obj.Angle	= 0
		
		// 登録
		GameObjectBase.constructor( obj, "Sub01", eObjType.Effect )
	}
	
	
	/*
	*	初期化
	*/
	function Init(o)
	{
		msgManager.SubCharaID = 0
	}
	
	
	/*
	*	通常動作
	*/
	function Move(o)
	{
		o.F0 += 0.01
		
		if( o.Link.HasParent ){
			local p = o.Link.Parent
			
			o.Dir = p.Dir
			o.Pos.X += (p.Pos.X - o.Pos.X + (o.Dir == DIR_LEFT ? 32 : -32)) / 8
			
			o.Pos.Y = p.Pos.Y
			o.Pos.Y -= 32 + 10 * sin( o.F0 * PI * 2 )
			
			o.L1 = 0
			
			
			o.Angle = (o.Dir == DIR_LEFT ? 0.5 : 0.0)
		}
	}


	/*
	*	描画
	*/
	function Draw(o)
	{
		msgManager.Update()
		msgManager.Draw()
	}
}


class Kanban extends GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor()
	{
		// テクスチャ登録
		this.RegistTexture( "mapchi_obj.png", "Kanban", 0, 40*0, 40*0, 40, 40 )
		
		// 各パラメータ設定
		local obj = GameObject.IObject()
		obj.Texture	= "Kanban"
		
		// コリジョン設定
		local detail = GameObject.SColDetail.ctorRect( -20, -20, 20, 20 )
		detail.Target = 1
		obj.Col.PushDetail( detail )

		// 登録
		GameObjectBase.constructor( obj, "Kanban", eObjType.Effect )
	}
	
	
	/*
	*	コリジョン
	*/
	function Col(o1, o2, c1, c2)
	{
		msgManager.Set( o1.L0, o1.L1 )
	}
}




Sub01()
Kanban()
