﻿/*
*	うおーく
*/


enum eWalkState
{
	Ready,			// デフォルト。待機
	Begin,			// 
	Begin_NoBrake,	// 
	Walk,			// 
	Brake,			// 
}


class Walk
{
	o	= null
	
	ing		= false
	state	= eWalkState.Ready
	frame	= 0


	/*
	*	
	*/
	function Init(obj)
	{
		o	= obj
	}


	/*
	*	
	*/
	function Action(pad)
	{
		++frame

		local hold = {
			free	=  pad.IsFree( PAD_DIR_LEFT ) && pad.IsFree( PAD_DIR_RIGHT ),
			left	=  pad.IsHold( PAD_DIR_LEFT ),
			right	= !pad.IsHold( PAD_DIR_LEFT ) && pad.IsHold( PAD_DIR_RIGHT ),
		}
		


		// 左右入力
		switch( state ){
			case eWalkState.Ready:
			case eWalkState.Begin:
			case eWalkState.Begin_NoBrake:
				o.Speed.X	+= 0.15 * (hold.left ? -1 : (hold.right ? 1 : 0))
				o.Dir		= (hold.left ? DIR_LEFT : (hold.right ? DIR_RIGHT : o.Dir))
				break
		}
		
		
		local newState = -1
		
		
		switch( state ){
			case eWalkState.Ready:
				// 待機
				local speed = 0.5
				if     ( o.Speed.X < 0 ){ if( (o.Speed.X += speed) > 0 ) o.Speed.X = 0 }
				else if( o.Speed.X > 0 ){ if( (o.Speed.X -= speed) < 0 ) o.Speed.X = 0 }
				
				if( hold.left || hold.right ) newState = eWalkState.Begin
				break
				
			case eWalkState.Begin:
				// 歩き出し
				if     ( hold.free  ){ newState = eWalkState.Ready; o.Speed.X = 0 }
				else if( frame >= 8 ){ newState = eWalkState.Walk }
				break
				
			case eWalkState.Begin_NoBrake:
				// ブレーキからの歩き出し
				if     ( hold.free  ) newState = eWalkState.Brake
				else if( frame >= 4 ) newState = eWalkState.Walk
				break
				
			case eWalkState.Walk:
				// あるき
				local speed = 1.5
				
				if( hold.free ){
					newState = eWalkState.Brake
				}
				else if( hold.left ){
					if( o.Speed.X <= 0 ){ o.Dir = DIR_LEFT; o.Speed.X -= speed }
					else                { newState = eWalkState.Brake }
				}
				else if( hold.right ){
					if( o.Speed.X >= 0 ){ o.Dir = DIR_RIGHT; o.Speed.X += speed }
					else                { newState = eWalkState.Brake }
				}
				break
				
			case eWalkState.Brake:
				// ブレーキ
				local speed = { free = 0.8, hold = 0.8 }
				
				if( hold.free ){
					if     ( o.Speed.X < 0 ){ if( (o.Speed.X += speed.free) > 0 ) o.Speed.X = 0 }
					else if( o.Speed.X > 0 ){ if( (o.Speed.X -= speed.free) < 0 ) o.Speed.X = 0 }
					
					if( o.Speed.X == 0 ) newState = eWalkState.Ready
				}
				else if( hold.left ){
					if     (  o.Speed.X                <  0 ){ newState = eWalkState.Begin_NoBrake }
					else if( (o.Speed.X -= speed.hold) <= 0 ){ newState = eWalkState.Begin_NoBrake; o.Dir = DIR_LEFT }
				}
				else if( hold.right ){
					if     (  o.Speed.X                >  0 ){ newState = eWalkState.Begin_NoBrake }
					else if( (o.Speed.X += speed.hold) >= 0 ){ newState = eWalkState.Begin_NoBrake; o.Dir = DIR_RIGHT }
				}
				break
		}
		
		
		if( newState != -1 ){ state = newState; frame = 0 }
	}
	
	
	/*
	*	
	*/
	function Draw(srcPoint)
	{
		switch( state ){
			case eWalkState.Ready:
				// 立ち
				local src = [ 0, 1, 2, 3 ]
				
				if( frame >= 10 * src.len() ) frame = 0
				
				for(local i=0; i < src.len(); ++i)
					if( frame < 10 * (i+1) ){ o.Src.X += o.Src.W * src[i]; break }
				break
				
			case eWalkState.Begin:
				if( frame < 4 ) srcPoint.X = 4
				else            srcPoint.X = 5
				break
				
			case eWalkState.Begin_NoBrake:
				srcPoint.X = 5
				break
				
			case eWalkState.Walk:
				// 歩き
				srcPoint.Y = 1
				
				local src = [ 0, 1, 2, 3, 4, 5, null ]
				
				foreach(i, v in src)
					if( frame < 7 * (i+1) ){
						if( v == null ){ srcPoint.X = src[0]; frame = 0 }
						else             srcPoint.X = v
						break
					}
				break
				
			case eWalkState.Brake:
				srcPoint.Y = 2
				if     ( frame < 2 ) srcPoint.X = 0
				else if( frame < 4 ) srcPoint.X = 1
				else                 srcPoint.X = 2
				break
		}
	}
	
	
	/*
	*	
	*/
	function Finish()
	{
		state	= eWalkState.Ready
		frame	= 0
	}
}
