﻿/*
*	共通っぽい
*/



// オブジェクトタイプ
enum eObjType
{
	Player		= 0x01,
	Object		= 0x02,
	Enemy		= 0x04,
	PlayerAtk	= 0x08,
	Effect		= 0x10,
}


class GameObjectBase
{
	/*
	*	コンストラクタ
	*/
	constructor(obj, name, objectType)
	{
		local reg = GameObject.CRegister()
		
		if( this.Init        != null ) obj.Action.Init        = this.Init
		if( this.Move        != null ) obj.Action.Move        = this.Move
		if( this.Draw        != null ) obj.Action.Draw        = this.Draw
		if( this.Dead        != null ) obj.Action.Dead        = this.Dead
		if( this.Col         != null ) obj.Action.Col         = this.Col
		if( this.ColTreatMap != null ) obj.Action.ColTreatMap = this.ColTreatMap
		reg.Regist( name, obj, objectType )
	}
	
	
	/*
	*	テクスチャ
	*/
	function RegistTexture(fileName, keyName, prio, x, y, w, h)
	{
		My.CTextureInterface().CreateTexture( fileName, STextureState() )
			.Regist( keyName, prio, x, y, w, h )
	}
	
	
	// 各関数
	Init		= null	// function (o)
	Move		= null	// function (o)
	Draw		= null	// function (o)
	Dead		= null	// function (o)
	Col			= null	// function (o1, o2, c1, c2)
	ColTreatMap	= null	// function (o1, o2)
}


g_id <- -1

class CSqParam
{
	id			= null
	frame		= null
	state		= null
	stateSub	= null
	boundDir	= null
	landObjList	= null
	
	constructor()
	{
		id			= ++g_id
		frame		= 0
		state		= 0
		stateSub	= 0
		boundDir	= DIR_INVALID
		landObjList	= []
	}
	function Update()
	{
		++frame
	}
	function Reset()
	{
		frame		= 0
		state		= 0
		stateSub	= 0
	}
}




function getVector2D (speed, angle)
{
	local rad = angle * PI * 2
	return SPoint2DF.ctor( speed * cos(rad), speed * sin(rad) )
}

function getVector2D_Rand (minSpeed, maxSpeed, decSpeed, minAngle, maxAngle, decAngle)
{
	local randVal = rand()
	
	local powSpeed = pow( 10, decSpeed )
	local powAngle = pow( 10, decAngle )
	local speed = minSpeed + (randVal % ((maxSpeed - minSpeed) * powSpeed + 1)) / powSpeed
	local angle = minAngle + (randVal % ((maxAngle - minAngle) * powAngle + 1)) / powAngle
	
	return getVector2D( speed, angle )
}
